using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Styles;



namespace SampleSorting
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private DataTable dt = new DataTable("LookUpTable");
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl sortGrouping;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			CreateTable();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			sortGrouping.DataSource = dt;
			this.sortGrouping.TableDescriptor.Columns["Sort"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
			this.sortGrouping.TableDescriptor.Columns["Sort"].Appearance.AnyRecordFieldCell.DataSource = dt.Copy().DefaultView;
			this.sortGrouping.TableDescriptor.Columns["Sort"].Appearance.AnyRecordFieldCell.ValueMember =  "Lookup_id";
			this.sortGrouping.TableDescriptor.Columns["Sort"].Appearance.AnyRecordFieldCell.DisplayMember =	"Lookup_member";
			this.sortGrouping.TableDescriptor.Columns["Sort"].Width = 80;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sortGrouping = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.sortGrouping)).BeginInit();
			this.SuspendLayout();
			// 
			// sortGrouping
			// 
			this.sortGrouping.BackColor = System.Drawing.SystemColors.Window;
			this.sortGrouping.Dock = System.Windows.Forms.DockStyle.Fill;
			this.sortGrouping.Location = new System.Drawing.Point(0, 0);
			this.sortGrouping.Name = "sortGrouping";
			this.sortGrouping.Size = new System.Drawing.Size(344, 254);
			this.sortGrouping.TabIndex = 0;
			this.sortGrouping.Text = "gridGroupingControl1";
			this.sortGrouping.VersionInfo = "3.301.0.0";
			this.sortGrouping.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.sortGrouping_TableControlQueryAllowSortColumn);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(344, 254);
			this.Controls.Add(this.sortGrouping);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.sortGrouping)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void CreateTable() {
			dt.Columns.Add("Lookup_id", System.Type.GetType("System.Int32") );
			dt.Columns.Add("Lookup_member", System.Type.GetType("System.String"));
			dt.Columns.Add("Sort", System.Type.GetType("System.String"));

			DataRow dr = dt.NewRow();
			dr["Lookup_id"] = 1;
			dr["Lookup_member"] = "Mitesh";
			dr["Sort"] = 1;

			dt.Rows.Add(dr);
			
			dr = dt.NewRow();
			dr["Lookup_id"] = 2;
			dr["Lookup_member"] = "Brian";
			dr["Sort"] = 2;

			dt.Rows.Add(dr);

			dr = dt.NewRow();
			dr["Lookup_id"] = 3;
			dr["Lookup_member"] = "Calvin";
			dr["Sort"] = 3;

			dt.Rows.Add(dr);

			dr = dt.NewRow();
			dr["Lookup_id"] = 4;
			dr["Lookup_member"] = "Paul";
			dr["Sort"] = 4;

			dt.Rows.Add(dr);

		}

		private void sortGrouping_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			GridTableDescriptor td = e.TableControl.TableDescriptor;
			
			if(e.Column.Name == "Sort")
			{
				e.AllowSort = false;
				if(td.SortedColumns.Contains("Sort"))
				{
					if (td.SortedColumns["Sort"].SortDirection == System.ComponentModel.ListSortDirection.Ascending)
					{
						td.SortedColumns["Sort"].SortDirection = System.ComponentModel.ListSortDirection.Descending;
						e.Column.Appearance.ColumnHeaderCell.Tag = System.ComponentModel.ListSortDirection.Descending;
					}
					else
					{
						td.SortedColumns["Sort"].SortDirection = System.ComponentModel.ListSortDirection.Ascending;
						e.Column.Appearance.ColumnHeaderCell.Tag = System.ComponentModel.ListSortDirection.Ascending;

					}
				}
				else
				{
										
					if(Control.ModifierKeys != Keys.Control)
						td.SortedColumns.Clear();
					td.SortedColumns.Add("Sort", System.ComponentModel.ListSortDirection.Ascending);
					td.SortedColumns["Sort"].Comparer = new DisplayMemberComparer(dt);
					e.Column.Appearance.ColumnHeaderCell.Tag = System.ComponentModel.ListSortDirection.Ascending;

				}
				
			}
			else
				if(Control.ModifierKeys != Keys.Control && td.SortedColumns.Contains("Sort"))
			{
				td.SortedColumns.Remove("Sort");
				td.Columns["Sort"].Appearance.ColumnHeaderCell.Tag = null;
			}


		}
		
	}

	public class DisplayMemberComparer : IComparer
	{
		DataTable dt = null;
		public DisplayMemberComparer(DataTable dt)
		{
			this. dt = dt;
		}
		#region Implementation of IComparer
		public int Compare(object x, object y)
		{
			if(x == null && y == null)
				return 0;
			else if(x == null)
				return -1;
			else if(y == null)
				return 1;
			else
			{
				try
				{
					DataRow[] dr = dt.Select("Lookup_id = "+x.ToString());
					string xDM = dr[0]["Lookup_member"].ToString();
					dr = dt.Select("Lookup_id = "+y.ToString());
					string yDM = dr[0]["Lookup_member"].ToString();
					
					return xDM.CompareTo(yDM);
				}
				catch 
				{
					throw new ArgumentException("Lookup id not found...");
				}
				
			
			}
		}
	
		#endregion
	}
}
